<?php
namespace Bitrix\Main;

use \Bitrix\Main\Localization\Loc;

/**
 * Exception is thrown when the type of an argument is not accepted by function.
 */
class ArgumentTypeException
	extends ArgumentException
{
	protected $requiredType;
	protected $realType;

	/**
	 * Creates new exception object
	 *
	 * @param string $parameter Argument that generates exception
	 * @param string $requiredType Required type
	 * @param string $realType
	 * @param \Exception $previous
	 */
	public function __construct($parameter = "", $requiredType = "", $realType = "", \Exception $previous = null)
	{
		$message = Loc::getMsg(
			"argument_type_exception_message",
			array(
				"#PARAMETER#" => $parameter,
				"#REQUIRED_TYPE#" => $requiredType,
				"#REAL_TYPE#" => $realType,
			)
		);
		$this->requiredType = $requiredType;
		$this->realType = $realType;
		parent::__construct($message, $parameter, $previous);
	}

	public function getRequiredType()
	{
		return $this->requiredType;
	}

	public function getRealType()
	{
		return $this->realType;
	}
}
