<?php
namespace Bitrix\Main\DB;

class MysqliDbResult
	extends DbResult
{
	private $resultFields = array();

	public function __construct(DbConnection $dbConnection, $result, \Bitrix\Main\Diag\SqlTrackerQuery $trackerQuery = null)
	{
		parent::__construct($dbConnection, $result, $trackerQuery);
	}

	protected function convertDataFromDb($value, $fieldType)
	{
		switch ($fieldType)
		{
			case 12:
			case 7:
				return \Bitrix\Main\Type\DateTime::createFromFormat("Y-m-d H:i:s", $value);
				break;
			case 10:
				return \Bitrix\Main\Type\DateTime::createFromFormat("Y-m-d", $value);
				break;
			default:
				break;
		}

		return $value;
	}

	public function getSelectedRowsCount()
	{
		/** @var $r \mysqli_result */
		$r = $this->resultResource;

		return $r->num_rows;
	}

	public function getAffectedRowsCount()
	{
		/** @var $con \mysqli */
		$con = $this->connection->getConnectionResource();

		return $con->affected_rows;
	}

	public function getFieldsCount()
	{
		$con = $this->connection->getConnectionResource();
		/** @var $con \mysqli */

		return $con->field_count;
	}

	public function getFieldName($column)
	{
		/** @var $r \mysqli_result */
		$r = $this->resultResource;

		return $r->fetch_field_direct($column);
	}

	public function getResultFields()
	{
		if (empty($this->resultFields))
		{
			/** @var $r \mysqli_result */
			$r = $this->resultResource;
			$resultFields = $r->fetch_fields();
			$this->resultFields = array();
			foreach ($resultFields as $key => $value)
				$this->resultFields[$key] = array(
					"name" => $resultFields[$key]->name,
					"type" => $resultFields[$key]->type,
				);
		}

		return $this->resultFields;
	}

	protected function fetchRowInternal()
	{
		/** @var $r \mysqli_result */
		$r = $this->resultResource;
		return $r->fetch_row();
	}
}
