<?php
namespace Bitrix\Main\Type;

class DateTime
	extends \DateTime
{
	const DATE_WITH_TIME = 0;
	const DATE_WITHOUT_TIME = 1;

	/*public function toString()
	{
		$userTimezone = new DateTimeZone('America/New_York');
		$gmtTimezone = new DateTimeZone('GMT');
		$myDateTime = new DateTime('2009-03-21 13:14', $gmtTimezone);
		$offset = $userTimezone->getOffset($myDateTime);
		echo $offset;

		will print -14400, or 4 hours (because New York is on DST).

		This is where the DateTime::add method would come in handy because we could just add the offset. Unfortunately, it is not available until PHP 5.3 so we need to do the calculation manually by converting to Unix timestamp.

		echo date('Y-m-d H:i', $myDateTime->format('U') + $offset)
	}*/

	public function toString(\Bitrix\Main\Localization\Culture $culture, $type = self::DATE_WITH_TIME)
	{
		$format = ($type == self::DATE_WITH_TIME) ? $culture->getDateTimeFormat() : $culture->getDateFormat();
		return $this->format($format);
	}

	public function __toString()
	{
		$context = \Bitrix\Main\Application::getCurrent()->getContext();
		return $this->toString($context->getCulture());
	}
}
