<?if(!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED!==true) die();

if (!IsModuleInstalled("vote")):
	ShowError(GetMessage("VOTE_MODULE_IS_NOT_INSTALLED"));
	return;
elseif (intVal($arParams["VOTE_ID"]) <= 0):
	ShowError(GetMessage("VOTE_EMPTY"));
	return;
endif;
if (!function_exists("_GetAnswerArray"))
{
	function _GetAnswerArray($AnswerID, $FieldType, &$arAnswers)
	{
		$arReturn = array();
		foreach ($arAnswers as $keyA => $arAnswer)
		{
			if ($arAnswer["FIELD_TYPE"] == $FieldType)
			{
				$arReturn[] = $arAnswer;
				if ($AnswerID != $keyA)
					unset($arAnswers[$keyA]);
			}
		}
		return $arReturn;
	}
}
/********************************************************************
				Input params
********************************************************************/
/************** BASE ***********************************************/
	$arParams["VOTE_ID"] = intVal($arParams["VOTE_ID"]);
	$arParams["PERMISSION"] = (isset($arParams["PERMISSION"]) && (intval($arParams["PERMISSION"] > 0 || $arParams["PERMISSION"] === 0) ?
		intval($arParams["PERMISSION"]) : false));
/************** URL ************************************************/
	$URL_NAME_DEFAULT = array(
			"vote_result" => "PAGE_NAME=vote_result&VOTE_ID=#VOTE_ID#");
	foreach ($URL_NAME_DEFAULT as $URL => $URL_VALUE):
		if (strLen(trim($arParams[strToUpper($URL)."_TEMPLATE"])) <= 0)
			$arParams[strToUpper($URL)."_TEMPLATE"] = $APPLICATION->GetCurPage()."?".$URL_VALUE;
		$arParams["~".strToUpper($URL)."_TEMPLATE"] = $arParams[strToUpper($URL)."_TEMPLATE"];
		$arParams[strToUpper($URL)."_TEMPLATE"] = htmlspecialcharsbx($arParams["~".strToUpper($URL)."_TEMPLATE"]);
	endforeach;
/************** CACHE **********************************************/
	if ($arParams["CACHE_TYPE"] == "Y" || ($arParams["CACHE_TYPE"] == "A" && COption::GetOptionString("main", "component_cache_on", "Y") == "Y"))
		$arParams["CACHE_TIME"] = intval($arParams["CACHE_TIME"]);
	else
		$arParams["CACHE_TIME"] = 0;

	$arParams["ADDITIONAL_CACHE_ID"] = (isset($arParams["ADDITIONAL_CACHE_ID"]) && strlen($arParams["ADDITIONAL_CACHE_ID"]) > 0 ?
		$arParams["ADDITIONAL_CACHE_ID"] : $USER->GetGroups());
/********************************************************************
				/Input params
********************************************************************/
if ($GLOBALS["VOTING_OK"] == "Y"  && ($GLOBALS["VOTING_ID"] == $arParams["VOTE_ID"]))
{
	$strNavQueryString = DeleteParam(array("VOTE_ID", "VOTING_OK", "VOTE_SUCCESSFULL", "view_result", "view_form"));
	$strNavQueryString .= ($strNavQueryString <> "" ? "&" : "");
	$delimiter = (strpos($arParams["VOTE_RESULT_TEMPLATE"], "?") === false) ? "?":"&";
	if (strpos($arParams["VOTE_RESULT_TEMPLATE"], "#VOTE_ID#") === false)
	{
		$arParams["VOTE_RESULT_TEMPLATE"] .= $delimiter."VOTE_ID=".$_REQUEST["VOTE_ID"];
		$url = CComponentEngine::MakePathFromTemplate(
			$arParams["VOTE_RESULT_TEMPLATE"]."&VOTE_SUCCESSFULL=Y".$strNavQueryString);
	} else {
		$url = CComponentEngine::MakePathFromTemplate(
			$arParams["VOTE_RESULT_TEMPLATE"].$delimiter."VOTE_SUCCESSFULL=Y".$strNavQueryString,
			array("VOTE_ID" => $arParams["VOTE_ID"]));
	}
	LocalRedirect($url);
}
/********************************************************************
				Default values
********************************************************************/
$arResult["OK_MESSAGE"] = "";
$arResult["ERROR_MESSAGE"] = "";

$arResult["CHANNEL"] = array();
$arResult["VOTE"] = array();
$arResult["QUESTIONS"] = array();
$arResult["GROUP_ANSWERS"] = array();

$arResult["~CURRENT_PAGE"] = $APPLICATION->GetCurPageParam("", array("VOTE_ID","VOTING_OK","VOTE_SUCCESSFULL"));
$arResult["CURRENT_PAGE"] = htmlspecialcharsbx($arResult["~CURRENT_PAGE"]);

$arError = array(); $arNote = array();
if (($GLOBALS["VOTING_OK"] == "Y" || $_REQUEST["VOTE_SUCCESSFULL"] == "Y") && ($_REQUEST["VOTE_ID"] == $arParams["VOTE_ID"])) 
	$arNote[] = array("id" => "ok", "text" => GetMessage("VOTE_OK"));
if (($GLOBALS["USER_ALREADY_VOTE"] == "Y") && ($_REQUEST["VOTE_ID"] == $arParams["VOTE_ID"]))
	$arError[] = array("id" => "already vote", "text" => GetMessage("VOTE_ALREADY_VOTE"));
if (($GLOBALS["VOTING_LAMP"] == "red") && ($_REQUEST["VOTE_ID"] == $arParams["VOTE_ID"]))
	$arError[] = array("id" => "red lamp", "text" => GetMessage("VOTE_RED_LAMP"));
if (($GLOBALS["NO_CAPTCHA"] == "Y") && ($_REQUEST["VOTE_ID"] == $arParams["VOTE_ID"]))
	$arError[] = array("id" => "no captcha", "text" => GetMessage("VOTE_NO_CAPTCHA"));
if (($GLOBALS["BAD_CAPTCHA"] == "Y") && ($_REQUEST["VOTE_ID"] == $arParams["VOTE_ID"]))
	$arError[] = array("id" => "bad captcha", "text" => GetMessage("VOTE_BAD_CAPTCHA"));
if ((($GLOBALS["VOTE_REQUIRED_MISSING"]) == "Y")  && ($_REQUEST["VOTE_ID"] == $arParams["VOTE_ID"]))
	$arError[] = array("id" => "required question is not answered", "text" => GetMessage("VOTE_REQUIRED_MISSING"));
if (($GLOBALS["USER_VOTE_EMPTY"] == "Y") && (empty($arError)) && ($GLOBALS["VOTING_ID"] == $arParams["VOTE_ID"]))
	$arError[] = array("id" => "user vote empty", "text" => GetMessage("USER_VOTE_EMPTY"));
/********************************************************************
				/Default values
********************************************************************/

/********************************************************************
				Data
********************************************************************/
$obCache = new CPHPCache;
$cache_id = "vote_form_".serialize(array($arParams["VOTE_ID"], $arParams["ADDITIONAL_CACHE_ID"],
	(isset($arParams["PERMISSION"]) ? $arParams["PERMISSION"] : array()))).
	((($tzOffset = CTimeZone::GetOffset()) <> 0) ? "_".$tzOffset : "");
$cache_path = str_replace(array(":", "//"), "/", "/".SITE_ID."/".$componentName);

if ($obCache->InitCache($arParams["CACHE_TIME"], $cache_id, $cache_path))
{
	$arVars = $obCache->GetVars();
	$arResult = $arVars["arResult"];
}
else
{
	CModule::IncludeModule("vote");
	$tmp = array();
	$arParams["VOTE_ID"] = GetVoteDataByID($arParams["VOTE_ID"],
		$arChannel, $arVote, $arQuestions, $arAnswers,
		$tmp["DropDown"], $tmp["MultiSelect"], $tmp["GroupAnswers"]);
	$permission = ($arParams["PERMISSION"] === false ? CVoteChannel::GetGroupPermission($arChannel["ID"]) : $arParams["PERMISSION"]);

	if ($permission < 2)
	{
		$arError[] = array(
			"id" => "access denied", 
			"text" => GetMessage("VOTE_ACCESS_DENIED"));
	}
	else
	{
		//Vote Image
		$arVote["IMAGE"] = CFile::GetFileArray($arVote["IMAGE_ID"]);
		$arResult["VOTE"] = $arVote;

		$arResult["CHANNEL"] = $arChannel;

		$defaultWidth = "10"; $defaultHeight = "5"; $questionSize = count($arQuestions);
		foreach ($arQuestions as $key => $arQuestion)
		{
			if (empty($arQuestion["ANSWERS"]))
				continue;
			//Images
			$arQuestion["IMAGE"] = CFile::GetFileArray($arQuestion["IMAGE_ID"]);
			foreach ($arQuestion["ANSWERS"] as $keya => $arAnswer)
			{
//				$arQuestion["ANSWERS"][$keya] += array("DROPDOWN" => array(), "MULTISELECT" => array());
				if ($arAnswer["FIELD_TYPE"] == 2 || $arAnswer["FIELD_TYPE"] == 3)
				{
					$arQuestion["ANSWERS"][$keya][$arAnswer["FIELD_TYPE"] == 2 ? "DROPDOWN" : "MULTISELECT"] =
						_GetAnswerArray($keya, $arAnswer["FIELD_TYPE"], $arQuestion["ANSWERS"]);
				}
				elseif ($arAnswer["FIELD_TYPE"] == 4 || $arAnswer["FIELD_TYPE"] == 5)
				{
					$arQuestion["ANSWERS"][$keya]["FIELD_WIDTH"] = (!!$arAnswer["FIELD_WIDTH"] ? intval($arAnswer["FIELD_WIDTH"]) : $defaultWidth);
					if ($arAnswer["FIELD_TYPE"] == 5)
						$arQuestion["ANSWERS"][$keya]["FIELD_HEIGHT"] = (!!$arAnswer["FIELD_HEIGHT"] ? intval($arAnswer["FIELD_HEIGHT"]) : $defaultHeight);
				}
			}
			$arResult["QUESTIONS"][$key] = $arQuestion;
		}
	
		global $CACHE_MANAGER;
		$obCache->StartDataCache();
		$CACHE_MANAGER->StartTagCache($cache_path);
		$CACHE_MANAGER->RegisterTag("vote_form_channel_".$arChannel["ID"]);
		$CACHE_MANAGER->RegisterTag("vote_form_vote_".$arVote["ID"]);
		foreach($arQuestions as $question)
		{
			$CACHE_MANAGER->RegisterTag("vote_form_question_".$question["ID"]);
		}
		$CACHE_MANAGER->EndTagCache();
		$obCache->EndDataCache(array("arResult" => $arResult));
	}
}

if ($arResult["CHANNEL"]["USE_CAPTCHA"] == "Y") 
{
	include_once($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/classes/general/captcha.php");
	$cpt = new CCaptcha();
	$captchaPass = COption::GetOptionString("main", "captcha_password", "");
	if (empty($captchaPass))
	{
		$captchaPass = randString(10);
		COption::SetOptionString("main", "captcha_password", $captchaPass);
	}
	$cpt->SetCodeCrypt($captchaPass);
	$arResult["CAPTCHA_CODE"] = htmlspecialcharsbx($cpt->GetCodeCrypt());
}
if (!empty($arNote)):
	$e = new CAdminException($arNote);
	$arResult["OK_MESSAGE"] = $e->GetString();
endif;
if (!empty($arError)):
	$e = new CAdminException($arError);
	$arResult["ERROR_MESSAGE"] = $e->GetString();
endif;
/********************************************************************
				/Data
********************************************************************/
unset($arQuestions);
unset($arChannel);
unset($arVote);
unset($arAnswers);
unset($arDropDown);
unset($arMultiSelect);

$this->IncludeComponentTemplate();

//if (!empty($arParams["RETURN"]))
	return $arParams["RETURN"];
?>