<?if(!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED!==true) die();
if (!CModule::IncludeModule("vote")):
	ShowError(GetMessage("VOTE_MODULE_IS_NOT_INSTALLED"));
	return;
elseif (intVal($arParams["VOTE_ID"]) <= 0):
	ShowError(GetMessage("VOTE_EMPTY"));
	return;
endif;

require_once($_SERVER["DOCUMENT_ROOT"].$componentPath."/functions.php");
global $arrSaveColor;
require_once($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/img.php");
/********************************************************************
				Input params
********************************************************************/
/************** BASE ***********************************************/
	$arParams["VOTE_ID"] = intVal($arParams["VOTE_ID"]);
	$arParams["PERMISSION"] = (isset($arParams["PERMISSION"]) && ($arParams["PERMISSION"] > 0 || $arParams["PERMISSION"] === 0) ?
		intval($arParams["PERMISSION"]) : false);
/************** URL ************************************************/
	$URL_NAME_DEFAULT = array(
		"vote_form" => "PAGE_NAME=vote_new&VOTE_ID=#VOTE_ID#",
		"vote_result" => "PAGE_NAME=vote_result&VOTE_ID=#VOTE_ID#");
	foreach ($URL_NAME_DEFAULT as $URL => $URL_VALUE):
		if (strLen(trim($arParams[strToUpper($URL)."_TEMPLATE"])) <= 0)
			$arParams[strToUpper($URL)."_TEMPLATE"] = $APPLICATION->GetCurPage()."?".$URL_VALUE;
		$arParams["~".strToUpper($URL)."_TEMPLATE"] = $arParams[strToUpper($URL)."_TEMPLATE"];
		$arParams[strToUpper($URL)."_TEMPLATE"] = htmlspecialcharsbx($arParams["~".strToUpper($URL)."_TEMPLATE"]);
	endforeach;
/************** ADDITIONAL *****************************************/
	$arParams["SHOW_VOTED_USERS"] = ($arParams["SHOW_VOTED_USERS"] == "Y" ? "Y" : "N");
	$arParams["VOTE_ALL_RESULTS"] = "N";
/************** CACHE **********************************************/
	if ($arParams["CACHE_TYPE"] == "Y" || ($arParams["CACHE_TYPE"] == "A" && COption::GetOptionString("main", "component_cache_on", "Y") == "Y"))
		$arParams["CACHE_TIME"] = intval($arParams["CACHE_TIME"]);
	else
		$arParams["CACHE_TIME"] = 0;

	$arParams["ADDITIONAL_CACHE_ID"] = (isset($arParams["ADDITIONAL_CACHE_ID"]) && strlen($arParams["ADDITIONAL_CACHE_ID"]) > 0 ?
		$arParams["ADDITIONAL_CACHE_ID"] : $USER->GetGroups() );
/********************************************************************
				/Input params
********************************************************************/
$arParamsCache = array($arParams["ADDITIONAL_CACHE_ID"], $arParams["CACHE_TYPE"]);

if (($GLOBALS["VOTING_OK"] | $GLOBALS["USER_ALREADY_VOTE"] | $_REQUEST["VOTE_SUCCESSFULL"]) == "Y")
	$this->ClearResultCache($arParamsCache);
elseif (!$this->StartResultCache(false, $arParamsCache))
	return;
/********************************************************************
				Default values
********************************************************************/
$arResult["OK_MESSAGE"] = "";
$arResult["ERROR_MESSAGE"] = "";
$arResult["CHANNEL"] = array();
$arResult["VOTE"] = array();
$arResult["QUESTIONS"] = array();
$arResult["GROUP_ANSWERS"] = array();
$arResult["~CURRENT_PAGE"] = $APPLICATION->GetCurPageParam("", array("VOTE_ID","VOTING_OK","VOTE_SUCCESSFULL"));
$arResult["CURRENT_PAGE"] = htmlspecialcharsbx($arResult["~CURRENT_PAGE"]);
$arParams["NEED_SORT"] = ($arParams["NEED_SORT"] == "N" ? "N" : "Y");
$arResult["USERS"] = array();
$arResult["LAST_VOTE"] = false;
/********************************************************************
				/Default values
********************************************************************/

/********************************************************************
				Data
********************************************************************/
$arAnswers = $arDropDown = $arMultiSelect = array();
$arParams["VOTE_ID"] = GetVoteDataByID($arParams["VOTE_ID"],
	$arResult["CHANNEL"], $arResult["VOTE"],
	$arResult["QUESTIONS"], $arAnswers, $arDropDown, $arMultiSelect,
	$arResult["GROUP_ANSWERS"],
	array(
		"bGetUsersStat" => $arParams["SHOW_VOTED_USERS"],
		"bGetUserAnswerStat" => $arParams["VOTE_ALL_RESULTS"]
	)
);

if (intVal($arParams["VOTE_ID"]) <= 0):
	$this->AbortResultCache();
	ShowError(GetMessage("VOTE_NOT_FOUND"));
	return;
endif;

$arError = array(); $arNote = array();
if (($GLOBALS["VOTING_OK"] | $_REQUEST["VOTE_SUCCESSFULL"]) == "Y" && $_REQUEST["VOTE_ID"] == $arParams["VOTE_ID"])
	$arNote[] = array("id" => "ok", "text" => GetMessage("VOTE_OK"));
if (($GLOBALS["USER_ALREADY_VOTE"] == "Y") && ($_REQUEST["VOTE_ID"] == $arParams["VOTE_ID"]))
	$arError[] = array("id" => "already vote", "text" => GetMessage("VOTE_ALREADY_VOTE"));
if (($GLOBALS["VOTING_LAMP"] == "red") && ($_REQUEST["VOTE_ID"] == $arParams["VOTE_ID"]))
	$arError[] = array("id" => "red lamp", "text" => GetMessage("VOTE_RED_LAMP"));

$VOTE_ID = intval($arParams["VOTE_ID"]);

$permission = ($arParams["PERMISSION"] !== false ? intval($arParams["PERMISSION"]) : CVoteChannel::GetGroupPermission($arResult["CHANNEL"]["ID"]));

if ($permission >= 1)
{
	$counter = intval($arResult["VOTE"]["COUNTER"]);
	$counter = ($counter <= 0 ? 1 : $counter);

	if ($arParams["VOTE_ALL_RESULTS"] == "Y" && !empty($arResult["GROUP_ANSWERS"]))
	{
		foreach ($arResult["GROUP_ANSWERS"] as $answerId => $answerOptions)
		{
			$userAnswerSum = 0;
			foreach ($answerOptions as $answerOption)
			{
				$userAnswerSum += $answerOption["COUNTER"];
			}

			$ucolor = "\n";
			foreach ($answerOptions as $aID => $answerOption)
			{
				$ucolor = GetNextRGB($ucolor, count($answerOptions));
				$arResult["GROUP_ANSWERS"][$answerId][$aID]["COLOR"] = $ucolor;
				$arResult["GROUP_ANSWERS"][$answerId][$aID]["PERCENT"] = ($userAnswerSum > 0 ? round($answerOption["COUNTER"]*100/$userAnswerSum) : 0);
			}
		}
	}

	foreach ($arResult["QUESTIONS"] as $qID => $arQuestion)
	{
		//Include in the result chart
		if ($arQuestion["DIAGRAM"] == "N")
		{
			unset($arAnswers[$qID]);
			unset($arResult["QUESTIONS"][$qID]);
			continue;
		}
		elseif (empty($arQuestion["ANSWERS"]))
		{
			unset($arResult["QUESTIONS"][$qID]);
			continue;
		}

		//Calculating the sum and maximum value
		$counterSum = $counterMax = 0;
		foreach ($arQuestion["ANSWERS"] as $aID => $arAnswer)
		{
			if (empty($arAnswer["MESSAGE"]))
				unset($arQuestion["ANSWERS"][$aID]);

			$counterSum += $arAnswer["COUNTER"];
			$counterMax = max(intVal($arAnswer["COUNTER"]), $counterMax);
		}

		if ($arParams["NEED_SORT"] != "N")
			uasort($arQuestion["ANSWERS"], "_vote_answer_sort");
		$color = "";

		foreach ($arQuestion["ANSWERS"] as $aID => $arAnswer)
		{
			$arResult["USERS"] = array_merge(array_diff((!empty($arAnswer["USERS"]) ? explode(",", $arAnswer["USERS"]) : $arResult["USERS"]),$arResult["USERS"]),$arResult["USERS"]);
			$arResult["LAST_VOTE"] = ($arResult["LAST_VOTE"] === false ? $arAnswer["LAST_VOTE"] : $arResult["LAST_VOTE"]);
			$arResult["LAST_VOTE"] = min($arResult["LAST_VOTE"], $arAnswer["LAST_VOTE"]);
			$arAnswer["PERCENT"] = ($counterSum > 0 ? number_format(($arAnswer["COUNTER"]*100/$counter),0,",","") : 0);
			$arAnswer["BAR_PERCENT"] = ($arAnswer["FIELD_TYPE"] == 0 || $arAnswer["FIELD_TYPE"] == 2 ?  /* radio || dropdown */
				($counterMax > 0 ? round($arAnswer["COUNTER"]*100/$counterMax) : 0) : round($arAnswer["PERCENT"]));
			$arAnswer["COLOR"] = (empty($arAnswer["COLOR"]) && ($color = GetNextRGB($color, count($arQuestion["ANSWERS"]))) ?
				$color : TrimEx($arAnswer["COLOR"], "#"));
			$arQuestion["ANSWERS"][$aID] = $arAnswer;
		}
		$arResult["QUESTIONS"][$qID]["COUNTER_SUM"] = $counterSum;
		$arResult["QUESTIONS"][$qID]["COUNTER_MAX"] = $counterMax;

		//Images
		$arResult["QUESTIONS"][$qID]["IMAGE"] = CFile::GetFileArray($arResult["QUESTIONS"][$qID]["IMAGE_ID"]);

		//Diagram type
		if (!empty($arParams["QUESTION_DIAGRAM_".$qID]) && $arParams["QUESTION_DIAGRAM_".$qID]!="-")
			$arResult["QUESTIONS"][$qID]["DIAGRAM_TYPE"] = trim($arParams["QUESTION_DIAGRAM_".$qID]);

		//Answers
		$arResult["QUESTIONS"][$qID]["ANSWERS"] = $arQuestion["ANSWERS"];
	}

	//Vote Image
	$arResult["VOTE"]["IMAGE"] = CFile::GetFileArray($arResult["VOTE"]["IMAGE_ID"]);
}
else
{
	$arError[] = array(
		"id" => "access denied", 
		"text" => GetMessage("VOTE_ACCESS_DENIED"));
}
if (!empty($arNote)):
	$e = new CAdminException($arNote);
	$arResult["OK_MESSAGE"] = $e->GetString();
endif;

if (!empty($arError)):
	$e = new CAdminException($arError);
	$arResult["ERROR_MESSAGE"] = $e->GetString();
endif;
/********************************************************************
				/Data
********************************************************************/
if ($this->__templateName == "main_page.blue"):
	$this->__templateName = "main_page";
	$arParams["THEME"] = "blue";
elseif ($this->__templateName == "main_page.green"):
	$this->__templateName = "main_page";
	$arParams["THEME"] = "green";
endif;
$this->IncludeComponentTemplate();
if (!empty($arParams["RETURN"]))
	return $arParams["RETURN"];
?>